//
// Created by lukas on 06.03.21.
//

#include "ClockService.h"

ClockService::ClockService(AsyncWebServer* server, SecurityManager* securityManager) :
    _httpEndpoint(WordClockState::read,
                  WordClockState::update,
                  this,
                  server,
                  LIGHT_SETTINGS_ENDPOINT_PATH,
                  securityManager,
                  AuthenticationPredicates::IS_AUTHENTICATED),
    _webSocket(WordClockState::read,
               WordClockState::update,
               this,
               server,
               LIGHT_SETTINGS_SOCKET_PATH,
               securityManager,
               AuthenticationPredicates::IS_AUTHENTICATED),
    clock() {
  // configure settings service update handler to update LED state
  addUpdateHandler([&](const String& originId) { onConfigUpdated(); }, false);
}

void ClockService::begin() {
  _state.wordClockOn = DEFAULT_CLOCK_STATE;
  onConfigUpdated();
  clock.init();
}

void ClockService::onConfigUpdated() {
  //  digitalWrite(LED_PIN, _state.ledOn ? LED_ON : LED_OFF);
  if (_state.wordClockOn) {
    clock.turnOn();
  } else {
    clock.turnOff();
  }
}
