//
// Created by lukas on 06.03.21.
//

#ifndef LEDSTRIPINTERFACE_LOADANIMATOR_H
#define LEDSTRIPINTERFACE_LOADANIMATOR_H

#include <Ticker.h>
#include "LoadAnimationBase.h"

class LoadAnimator : public LoadAnimationBase {
 private:
  Ticker timer;
  uint8_t x, y, nro, nroo, nrooo;
  Adafruit_NeoPixel *strip;

  /**
   * one animation step to process the animation
   */
  void animationStep();

 public:
  LoadAnimator();

  /**
   * start the animation if not already runnint
   * @param strip pointer to strip object
   */
  void startLoadAnimation(Adafruit_NeoPixel *strip) override;

  /**
   * stop the animation
   */
  void stopLoadAnimation() override;

  bool animationActive() override;
};

#endif  // LEDSTRIPINTERFACE_LOADANIMATOR_H
